--- /usr/share/arduino/Arduino.mk.orig	2013-02-18 19:13:04.000000000 -0700
+++ /usr/share/arduino/Arduino.mk.new	2013-03-10 19:53:38.000000000 -0600
@@ -63,6 +63,11 @@
 #                            Goldenberg both reported this and
 #                            provided patches in the same spirit.
 #
+#         0.9  3.x.2013    Ben Hildred
+#			   - Fixed off by one problem on line numbers
+#			     in error messages.
+#			   - Basic autodetection of libraries.
+#
 ########################################################################
 #
 # STANDARD ARDUINO WORKFLOW
@@ -313,7 +318,12 @@
 CORE_LIB   = $(OBJDIR)/libcore.a
 
 # A list of dependencies
-DEP_FILE   = $(OBJDIR)/depends.mk
+DEP_FILE     = $(OBJDIR)/depends.mk
+LIB_DEP_FILE = $(OBJDIR)/libdep.mk
+
+ifndef ARDUINO_LIBS
+include $(LIB_DEP_FILE)
+endif
 
 # Names of executables
 CC      = $(AVR_TOOLS_PATH)/avr-gcc
@@ -415,11 +425,13 @@
 # the pde -> cpp -> o file
 $(OBJDIR)/%.cpp: %.pde
 	$(ECHO) '#include "WProgram.h"' > $@
+	$(ECHO) '#line 1' \"$<\" >> $@
 	$(CAT)  $< >> $@
 
 # the ino -> cpp -> o file
 $(OBJDIR)/%.cpp: %.ino
 	$(ECHO) '#include <Arduino.h>' > $@
+	$(ECHO) '#line 1' \"$<\" >> $@
 	$(CAT)  $< >> $@
 
 $(OBJDIR)/%.o: $(OBJDIR)/%.cpp
@@ -487,6 +499,10 @@
 $(CORE_LIB):	$(CORE_OBJS) $(LIB_OBJS)
 		$(AR) rcs $@ $(CORE_OBJS) $(LIB_OBJS)
 
+$(LIB_DEP_FILE):	$(OBJDIR) *.ino *.cpp *.c *.h *.pde
+		grep -h '^[ 	]*#[ 	]*include[ 	]*<' -- *.ino *.cpp *.c *.h *.pde|sed 's!^.*<\(.*\)\.h>.*!\1!'|sort -u|xargs -d '\n' echo 'ARDUINO_LIBS =' > $(LIB_DEP_FILE)
+		echo >> $(LIB_DEP_FILE)
+
 $(DEP_FILE):	$(OBJDIR) $(DEPS)
 		cat $(DEPS) > $(DEP_FILE)
 
